-- buAlignVert3.mcr Ver.0.4
-- Kazuhiro Kasiwagi (kasiwagi@ummb.jp)
-- _IĎs  hbOĐw  ҂I
-- shiftƂPTx݂ŃXibv
-- Oʐ}orthô
-- Xibvgƌڂ̐xɈˑ邩āAC}C`҂葵Ȃ悤
-- 
-- 0.4  XvCɑΉ
--      pxXibvPTx݂

macroScript buAlignVert3
	category:"Bu"
	buttontext:"AV3"
	toolTip:"buAlignVert3"
(
	local targetObj
	
	fn checkViewType = (
		case viewport.getType() of (
			#view_persp_user: false
			#view_camera: false
			#view_spot: false
			#view_shape: false
			default: true
		)
	)
	
	fn AlignVert3 mR1 mR2= (
		local sV = case subObjectLevel of (
						1: polyop.getVertSelection targetObj
						2: polyop.getVertsUsingEdge targetObj #selection
						3: polyop.getVertsUsingEdge targetObj #selection
						4: polyop.getVertsUsingFace targetObj #selection
						5: polyop.getVertsUsingFace targetObj #selection
						default: return()
					)
		local ap = cross (normalize (mR2.pos - mR1.pos)) mR1.dir
		
		for i in sV do (
			local vp = polyop.GetVert targetObj i
			polyop.setVert targetObj i (vp - ap * (dot (vp - mR1.pos) ap))
		)
	)
	
	fn AlignNot3 mR1 mR2= (
		local ap = cross (normalize (mR2.pos - mR1.pos)) mR1.dir
        for i = 1 to (numSplines targetObj) do (
            for j in (getKnotSelection targetObj i) do (
                local vp = getKnotPoint targetObj i j
                setKnotPoint targetObj i j (vp - ap * (dot (vp - mR1.pos) ap))
            )
        )
        updateShape targetObj
	)
	
	tool mtAlignVert3(
		local mR1,mR2,pAr=#()
		on mouseMove clickno do (
			pAr[2] = [viewPoint.x,viewPoint.y,0]
			
			if keyboard.shiftPressed then (
                p = pAr[2] - pAr[1]
                r = (floor ((atan2 p.y p.x) / 15 + 0.5)) * 15
                pAr[2] = pAr[1] + [cos r, sin r, 0] * length p
			)
			CompleteRedraw()
			gw.wPolyline pAr false rgb:#(red,red)
			gw.enlargeUpdateRect #whole
			gw.updateScreen()
            gw.resetUpdateRect()
		)
		on mousePoint clickno do (
			if clickno == 1 then (
				mR1 = mapScreenToWorldRay viewPoint
				pAr[1] = [viewPoint.x,viewPoint.y,0]
			) else (
				local v = viewPoint
				if keyboard.shiftPressed then (
                    p = pAr[2] - pAr[1]
                    r = (floor ((atan2 p.y p.x) / 15 + 0.5)) * 15
                    pAr[2] = pAr[1] + [cos r, sin r, 0] * length p
				)
				mR2 = mapScreenToWorldRay v
                if classof targetObj.baseobject == Editable_Poly do AlignVert3 mR1 mR2
                if classof targetObj.baseobject == line or classof targetObj.baseobject == SplineShape do AlignNot3 mR1 mR2
				#stop
			)
		)
		on mouseAbort clickno do loopF = false
	)
	On IsEnabled Return Filters.Is_EPoly() or Filters.Is_EditSpline()
	On IsVisible Return Filters.Is_EPoly() or Filters.Is_EditSpline()
	On Execute do (
		enableUndo off
		try (
            local oldser = showEndResult
            showEndResult = false
			if (targetObj = selection[1]) != undefined and checkViewType() do startTool mtAlignVert3
            showEndResult = oldser
		) catch ()
		enableUndo on
	)
)
